#include <QtGui>

#include "pluginwindow.h"
#include "plugininterface.h"

PluginWindow::PluginWindow()
{
    setFixedSize(640, 480);
	setWindowTitle("Plugin loader Example");
	setFont(QFont("monospace", 12));

   	if (loadPlugin("libfooplugin.so")) {
        layout()->addWidget(pinterface->widget(this));
    }
}


bool PluginWindow::loadPlugin(QString fileName)
{
	QDir pluginsDir(qApp->applicationDirPath());
	#if defined(Q_OS_WIN)
	if (pluginsDir.dirName().toLower() == "debug" || pluginsDir.dirName().toLower() == "release")
	    pluginsDir.cdUp();
	#elif defined(Q_OS_MAC)
	if (pluginsDir.dirName() == "MacOS") {
	    pluginsDir.cdUp();
	    pluginsDir.cdUp();
	    pluginsDir.cdUp();
	}
	#endif
	pluginsDir.cd("plugins");
	QPluginLoader pluginLoader(pluginsDir.absoluteFilePath(fileName));
	QObject *plugin = pluginLoader.instance();
	if (plugin) {
		pinterface = qobject_cast<PluginInterface *>(plugin);
		if (pinterface)
			return true;
		}

	return false;
}
